/*
 * (c) Copyright 2024 Swiss Post Ltd.
 */
CREATE TABLE QUEUED_COMPUTE_CHUNK_IDS_ENTITY
(
    ELECTION_EVENT_ID           VARCHAR(255) NOT NULL,
    VERIFICATION_CARD_SET_ID    VARCHAR(255) NOT NULL,
    CHUNK_ID                    NUMERIC(10) NOT NULL,
    CONSTRAINT QUEUED_COMPUTE_CHUNK_IDS_ENTITY_PK PRIMARY KEY (ELECTION_EVENT_ID, VERIFICATION_CARD_SET_ID, CHUNK_ID)
);

CREATE TABLE IN_PROGRESS_MESSAGE
(
    CORRELATION_ID             VARCHAR(255) NOT NULL,
    NODE_ID                    NUMERIC(10) NOT NULL,
    REQUEST_MESSAGE_TYPE       VARCHAR(255) NOT NULL,
    CONTEXT_ID                 VARCHAR(255) NOT NULL,
    RESPONSE_MESSAGE_TYPE      VARCHAR(255),
    RESPONSE_PAYLOAD           BYTEA,
    DETECTED_FOR_AGGREGATION   CHAR(1) DEFAULT 'N' NOT NULL,
    CONSTRAINT IN_PROGRESS_MESSAGE_PK PRIMARY KEY (CORRELATION_ID, NODE_ID)
);

CREATE TABLE CONTROL_COMPONENT_BALLOT_BOX_PAYLOAD
(
    ID                NUMERIC(18)  NOT NULL,
    ELECTION_EVENT_ID VARCHAR(100) NOT NULL,
    BALLOT_BOX_ID     VARCHAR(100) NOT NULL,
    NODE_ID           NUMERIC(10)  NOT NULL,
    PAYLOAD           BYTEA        NOT NULL,
    CHANGE_CONTROL_ID NUMERIC(10)  NOT NULL,
    CONSTRAINT CONTROL_COMPONENT_BALLOT_BOX_PAYLOAD_PK PRIMARY KEY (ID),
    CONSTRAINT CONTROL_COMPONENT_BALLOT_BOX_PAYLOAD_UK1 UNIQUE (ELECTION_EVENT_ID, BALLOT_BOX_ID, NODE_ID),
    CONSTRAINT CONTROL_COMPONENT_BALLOT_BOX_PAYLOAD_IMMUTABILITY_CK CHECK (CHANGE_CONTROL_ID = 0)
);
CREATE SEQUENCE CONTROL_COMPONENT_BALLOT_BOX_PAYLOAD_SEQ;

CREATE TABLE CONTROL_COMPONENT_VOTES_HASH_PAYLOAD
(
    ID                INTEGER       NOT NULL,
    ELECTION_EVENT_ID VARCHAR(255)  NOT NULL,
    BALLOT_BOX_ID     VARCHAR(255)  NOT NULL,
    NODE_ID           NUMERIC(10)   NOT NULL,
    PAYLOAD           BYTEA         NOT NULL,
    CHANGE_CONTROL_ID NUMERIC(9, 0) NOT NULL,
    CONSTRAINT CONTROL_COMPONENT_VOTES_HASH_PAYLOAD_PK PRIMARY KEY (ID),
    CONSTRAINT CONTROL_COMPONENT_VOTES_HASH_PAYLOAD_UK1 UNIQUE (BALLOT_BOX_ID, ELECTION_EVENT_ID, NODE_ID),
    CONSTRAINT CONTROL_COMPONENT_VOTES_HASH_PAYLOAD_IMMUTABILITY_CK CHECK (CHANGE_CONTROL_ID = 0)
);
CREATE SEQUENCE CONTROL_COMPONENT_VOTES_HASH_PAYLOAD_SEQ;

CREATE TABLE SHUFFLE_PAYLOAD
(
    ID                INTEGER       NOT NULL,
    ELECTION_EVENT_ID VARCHAR(255)  NOT NULL,
    BALLOT_BOX_ID     VARCHAR(255)  NOT NULL,
    NODE_ID           NUMERIC(10)   NOT NULL,
    PAYLOAD           BYTEA         NOT NULL,
    CHANGE_CONTROL_ID NUMERIC(9, 0) NOT NULL,
    CONSTRAINT SHUFFLE_PAYLOAD_PK PRIMARY KEY (ID),
    CONSTRAINT SHUFFLE_PAYLOAD_UK1 UNIQUE (BALLOT_BOX_ID, ELECTION_EVENT_ID, NODE_ID),
    CONSTRAINT SHUFFLE_PAYLOAD_IMMUTABILITY_CK CHECK (CHANGE_CONTROL_ID = 0)
);
CREATE SEQUENCE SHUFFLE_PAYLOAD_SEQ;


CREATE TABLE ENC_LONG_CODE_SHARE
(
    ID                       NUMERIC(18)  NOT NULL,
    ELECTION_EVENT_ID        VARCHAR(100) NOT NULL,
    VERIFICATION_CARD_SET_ID VARCHAR(100) NOT NULL,
    CHUNK_ID                 NUMERIC(10),
    NODE_ID                  NUMERIC(10)  NOT NULL,
    ENC_LONG_CODE_SHARE      BYTEA        NOT NULL,
    CHANGE_CONTROL_ID        NUMERIC(10)  NOT NULL,
    CONSTRAINT ENC_LONG_CODE_SHARE_PK PRIMARY KEY (ID),
    CONSTRAINT ENC_LONG_CODE_SHARE_UK1 UNIQUE (ELECTION_EVENT_ID, VERIFICATION_CARD_SET_ID, CHUNK_ID, NODE_ID),
    CONSTRAINT ENC_LONG_CODE_SHARE_IMMUTABILITY_CK CHECK (CHANGE_CONTROL_ID = 0)
);
CREATE SEQUENCE ENC_LONG_CODE_SHARE_SEQ;

CREATE TABLE WORKFLOW_SHELF
(
    ID            VARCHAR(100)             NOT NULL,
    SHELF_DATA    BYTEA                    NOT NULL,
    CREATION_DATE TIMESTAMP WITH TIME ZONE NOT NULL,
    CONSTRAINT WORKFLOW_SHELF_PK PRIMARY KEY (ID)
);

CREATE TABLE ELECTION_EVENT
(
    ELECTION_EVENT_ID VARCHAR(32) NOT NULL,
    ENCRYPTION_GROUP  BYTEA       NOT NULL,
    CHANGE_CONTROL_ID NUMERIC(1)  NOT NULL,
    CONSTRAINT ELECTION_EVENT_PK PRIMARY KEY (ELECTION_EVENT_ID),
    CONSTRAINT ELECTION_EVENT_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE ELECTION_EVENT_CONTEXT
(
    ELECTION_EVENT_ID          VARCHAR(32)              NOT NULL,
    START_TIME                 TIMESTAMP WITH TIME ZONE NOT NULL,
    FINISH_TIME                TIMESTAMP WITH TIME ZONE NOT NULL,
    ELECTION_EVENT_ALIAS       VARCHAR(50)              NOT NULL,
    ELECTION_EVENT_DESCRIPTION VARCHAR(255)             NOT NULL,
    CHANGE_CONTROL_ID          NUMERIC(1)               NOT NULL,
    CONSTRAINT ELECTION_EVENT_CONTEXT_PK PRIMARY KEY (ELECTION_EVENT_ID),
    FOREIGN KEY (ELECTION_EVENT_ID) REFERENCES ELECTION_EVENT (ELECTION_EVENT_ID),
    CONSTRAINT ELECTION_EVENT_CONTEXT_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE BALLOT_DATA
(
    BALLOT_ID            VARCHAR(32) NOT NULL,
    ELECTION_EVENT_FK_ID VARCHAR(32) NOT NULL,
    BALLOT               BYTEA       NOT NULL,
    BALLOT_TEXTS_JSON    BYTEA       NOT NULL,
    CHANGE_CONTROL_ID    NUMERIC(1)  NOT NULL,
    CONSTRAINT BALLOT_DATA_PK PRIMARY KEY (BALLOT_ID),
    FOREIGN KEY (ELECTION_EVENT_FK_ID) REFERENCES ELECTION_EVENT (ELECTION_EVENT_ID),
    CONSTRAINT BALLOT_DATA_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE SETUP_COMPONENT_PUBLIC_KEYS
(
    ELECTION_EVENT_ID                         VARCHAR(32) NOT NULL,
    CHOICE_RETURN_CODES_ENCRYPTION_PUBLIC_KEY BYTEA       NOT NULL,
    COMBINED_CONTROL_COMPONENT_PUBLIC_KEYS    BYTEA       NOT NULL,
    ELECTION_PUBLIC_KEY                       BYTEA       NOT NULL,
    ELECTORAL_BOARD_PUBLIC_KEY                BYTEA       NOT NULL,
    ELECTORAL_BOARD_SCHNORR_PROOFS            BYTEA       NOT NULL,
    CHANGE_CONTROL_ID                         NUMERIC(1)  NOT NULL,
    CONSTRAINT SETUP_COMPONENT_PUBLIC_KEYS_PK PRIMARY KEY (ELECTION_EVENT_ID),
    FOREIGN KEY (ELECTION_EVENT_ID) REFERENCES ELECTION_EVENT (ELECTION_EVENT_ID),
    CONSTRAINT SETUP_COMPONENT_PUBLIC_KEYS_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE VERIFICATION_CARD_SET
(
    VERIFICATION_CARD_SET_ID VARCHAR(32)              NOT NULL,
    ELECTION_EVENT_FK_ID     VARCHAR(32)              NOT NULL,
    BALLOT_BOX_ID            VARCHAR(32)              NOT NULL,
    GRACE_PERIOD             NUMERIC(5)               NOT NULL,
    PRIMES_MAPPING_TABLE     BYTEA                    NOT NULL,
    BALLOT_BOX_START_TIME    TIMESTAMP WITH TIME ZONE NOT NULL,
    BALLOT_BOX_FINISH_TIME   TIMESTAMP WITH TIME ZONE NOT NULL,
    TEST_BALLOT_BOX          CHAR(1) DEFAULT 'N'      NOT NULL,
    CHANGE_CONTROL_ID        NUMERIC(1)               NOT NULL,
    CONSTRAINT VERIFICATION_CARD_SET_PK PRIMARY KEY (VERIFICATION_CARD_SET_ID),
    FOREIGN KEY (ELECTION_EVENT_FK_ID) REFERENCES ELECTION_EVENT (ELECTION_EVENT_ID),
    CONSTRAINT GRACE_PERIOD_POSITIVITY_CK CHECK (GRACE_PERIOD >= 0),
    CONSTRAINT VERIFICATION_CARD_SET_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE RETURN_CODES_MAPPING_TABLE_ENTRY
(
    VERIFICATION_CARD_SET_ID    VARCHAR(32) NOT NULL,
    HASHED_LONG_RETURN_CODE     VARCHAR(44) NOT NULL,
    ENCRYPTED_SHORT_RETURN_CODE VARCHAR(48) NOT NULL,
    CHANGE_CONTROL_ID           NUMERIC(1)  NOT NULL,
    CONSTRAINT RETURN_CODES_MAPPING_TABLE_ENTRY_PK PRIMARY KEY (HASHED_LONG_RETURN_CODE),
    FOREIGN KEY (VERIFICATION_CARD_SET_ID) REFERENCES VERIFICATION_CARD_SET (VERIFICATION_CARD_SET_ID),
    CONSTRAINT RETURN_CODES_MAPPING_TABLE_ENTRY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE VERIFICATION_CARD
(
    VERIFICATION_CARD_ID        VARCHAR(32) NOT NULL,
    VERIFICATION_CARD_SET_FK_ID VARCHAR(32) NOT NULL,
    CREDENTIAL_ID               VARCHAR(32) NOT NULL UNIQUE,
    VOTING_CARD_ID              VARCHAR(32) NOT NULL,
    VOTER_AUTHENTICATION_DATA   BYTEA       NOT NULL,
    CHANGE_CONTROL_ID           NUMERIC(1)  NOT NULL,
    CONSTRAINT VERIFICATION_CARD_PK PRIMARY KEY (VERIFICATION_CARD_ID),
    FOREIGN KEY (VERIFICATION_CARD_SET_FK_ID) REFERENCES VERIFICATION_CARD_SET (VERIFICATION_CARD_SET_ID),
    CONSTRAINT VERIFICATION_CARD_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);
CREATE UNIQUE INDEX VOTING_CARD_ID_UK1 ON VERIFICATION_CARD (VOTING_CARD_ID);

CREATE TABLE SETUP_COMPONENT_VERIFICATION_CARD_KEYSTORE
(
    VERIFICATION_CARD_ID       VARCHAR(32) NOT NULL,
    VERIFICATION_CARD_KEYSTORE BYTEA       NOT NULL,
    CHANGE_CONTROL_ID          NUMERIC(1)  NOT NULL,
    CONSTRAINT SETUP_COMPONENT_VERIFICATION_CARD_KEYSTORE_PK PRIMARY KEY (VERIFICATION_CARD_ID),
    FOREIGN KEY (VERIFICATION_CARD_ID) REFERENCES VERIFICATION_CARD (VERIFICATION_CARD_ID),
    CONSTRAINT SETUP_COMPONENT_VERIFICATION_CARD_KEYSTORE_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);

CREATE TABLE VERIFICATION_CARD_STATE
(
    VERIFICATION_CARD_ID                     VARCHAR(32)              NOT NULL,
    SHORT_CHOICE_RETURN_CODES                BYTEA,
    SHORT_VOTE_CAST_RETURN_CODE              VARCHAR(8),
    STATE                                    NUMERIC(1)               NOT NULL,
    AUTHENTICATION_ATTEMPTS                  NUMERIC(1)               NOT NULL,
    LAST_SUCCESSFUL_AUTHENTICATION_TIME_STEP NUMERIC(19)              NOT NULL,
    SUCCESSFUL_AUTHENTICATION_ATTEMPTS       BYTEA                    NOT NULL,
    CONFIRMATION_ATTEMPTS                    NUMERIC(1)               NOT NULL,
    STATE_DATE                               TIMESTAMP WITH TIME ZONE NOT NULL,
    CHANGE_CONTROL_ID                        NUMERIC(10)              NOT NULL,
    CONSTRAINT VERIFICATION_CARD_STATE_PK PRIMARY KEY (VERIFICATION_CARD_ID),
    FOREIGN KEY (VERIFICATION_CARD_ID) REFERENCES VERIFICATION_CARD (VERIFICATION_CARD_ID)
);

CREATE TABLE IDEMPOTENT_EXECUTION
(
    CONTEXT           VARCHAR(255) NOT NULL,
    EXECUTION_KEY     VARCHAR(255) NOT NULL,
    CHANGE_CONTROL_ID NUMERIC(1)   NOT NULL,
    CONSTRAINT IDEMPOTENT_EXECUTION_PK PRIMARY KEY (CONTEXT, EXECUTION_KEY),
    CONSTRAINT IDEMPOTENT_EXECUTION_IMMUTABILITY_CK CHECK ( CHANGE_CONTROL_ID = 0 )
);



-- QUARTZ DATABASE SCRIPTS

CREATE TABLE QRTZ_JOB_DETAILS
(
    SCHED_NAME        VARCHAR(120) NOT NULL,
    JOB_NAME          VARCHAR(200) NOT NULL,
    JOB_GROUP         VARCHAR(200) NOT NULL,
    DESCRIPTION       VARCHAR(250) NULL,
    JOB_CLASS_NAME    VARCHAR(250) NOT NULL,
    IS_DURABLE        BOOL         NOT NULL,
    IS_NONCONCURRENT  BOOL         NOT NULL,
    IS_UPDATE_DATA    BOOL         NOT NULL,
    REQUESTS_RECOVERY BOOL         NOT NULL,
    JOB_DATA          BYTEA        NULL,
    PRIMARY KEY (SCHED_NAME, JOB_NAME, JOB_GROUP)
);

CREATE TABLE QRTZ_TRIGGERS
(
    SCHED_NAME     VARCHAR(120) NOT NULL,
    TRIGGER_NAME   VARCHAR(200) NOT NULL,
    TRIGGER_GROUP  VARCHAR(200) NOT NULL,
    JOB_NAME       VARCHAR(200) NOT NULL,
    JOB_GROUP      VARCHAR(200) NOT NULL,
    DESCRIPTION    VARCHAR(250) NULL,
    NEXT_FIRE_TIME BIGINT       NULL,
    PREV_FIRE_TIME BIGINT       NULL,
    PRIORITY       INTEGER      NULL,
    TRIGGER_STATE  VARCHAR(16)  NOT NULL,
    TRIGGER_TYPE   VARCHAR(8)   NOT NULL,
    START_TIME     BIGINT       NOT NULL,
    END_TIME       BIGINT       NULL,
    CALENDAR_NAME  VARCHAR(200) NULL,
    MISFIRE_INSTR  SMALLINT     NULL,
    JOB_DATA       BYTEA        NULL,
    PRIMARY KEY (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP),
    FOREIGN KEY (SCHED_NAME, JOB_NAME, JOB_GROUP)
        REFERENCES QRTZ_JOB_DETAILS (SCHED_NAME, JOB_NAME, JOB_GROUP)
);

CREATE TABLE QRTZ_SIMPLE_TRIGGERS
(
    SCHED_NAME      VARCHAR(120) NOT NULL,
    TRIGGER_NAME    VARCHAR(200) NOT NULL,
    TRIGGER_GROUP   VARCHAR(200) NOT NULL,
    REPEAT_COUNT    BIGINT       NOT NULL,
    REPEAT_INTERVAL BIGINT       NOT NULL,
    TIMES_TRIGGERED BIGINT       NOT NULL,
    PRIMARY KEY (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP),
    FOREIGN KEY (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP)
        REFERENCES QRTZ_TRIGGERS (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP)
);

CREATE TABLE QRTZ_CRON_TRIGGERS
(
    SCHED_NAME      VARCHAR(120) NOT NULL,
    TRIGGER_NAME    VARCHAR(200) NOT NULL,
    TRIGGER_GROUP   VARCHAR(200) NOT NULL,
    CRON_EXPRESSION VARCHAR(120) NOT NULL,
    TIME_ZONE_ID    VARCHAR(80),
    PRIMARY KEY (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP),
    FOREIGN KEY (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP)
        REFERENCES QRTZ_TRIGGERS (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP)
);

CREATE TABLE QRTZ_SIMPROP_TRIGGERS
(
    SCHED_NAME    VARCHAR(120)   NOT NULL,
    TRIGGER_NAME  VARCHAR(200)   NOT NULL,
    TRIGGER_GROUP VARCHAR(200)   NOT NULL,
    STR_PROP_1    VARCHAR(512)   NULL,
    STR_PROP_2    VARCHAR(512)   NULL,
    STR_PROP_3    VARCHAR(512)   NULL,
    INT_PROP_1    INT            NULL,
    INT_PROP_2    INT            NULL,
    LONG_PROP_1   BIGINT         NULL,
    LONG_PROP_2   BIGINT         NULL,
    DEC_PROP_1    NUMERIC(13, 4) NULL,
    DEC_PROP_2    NUMERIC(13, 4) NULL,
    BOOL_PROP_1   BOOL           NULL,
    BOOL_PROP_2   BOOL           NULL,
    PRIMARY KEY (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP),
    FOREIGN KEY (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP)
        REFERENCES QRTZ_TRIGGERS (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP)
);

CREATE TABLE QRTZ_BLOB_TRIGGERS
(
    SCHED_NAME    VARCHAR(120) NOT NULL,
    TRIGGER_NAME  VARCHAR(200) NOT NULL,
    TRIGGER_GROUP VARCHAR(200) NOT NULL,
    BLOB_DATA     BYTEA        NULL,
    PRIMARY KEY (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP),
    FOREIGN KEY (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP)
        REFERENCES QRTZ_TRIGGERS (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP)
);

CREATE TABLE QRTZ_CALENDARS
(
    SCHED_NAME    VARCHAR(120) NOT NULL,
    CALENDAR_NAME VARCHAR(200) NOT NULL,
    CALENDAR      BYTEA        NOT NULL,
    PRIMARY KEY (SCHED_NAME, CALENDAR_NAME)
);


CREATE TABLE QRTZ_PAUSED_TRIGGER_GRPS
(
    SCHED_NAME    VARCHAR(120) NOT NULL,
    TRIGGER_GROUP VARCHAR(200) NOT NULL,
    PRIMARY KEY (SCHED_NAME, TRIGGER_GROUP)
);

CREATE TABLE QRTZ_FIRED_TRIGGERS
(
    SCHED_NAME        VARCHAR(120) NOT NULL,
    ENTRY_ID          VARCHAR(95)  NOT NULL,
    TRIGGER_NAME      VARCHAR(200) NOT NULL,
    TRIGGER_GROUP     VARCHAR(200) NOT NULL,
    INSTANCE_NAME     VARCHAR(200) NOT NULL,
    FIRED_TIME        BIGINT       NOT NULL,
    SCHED_TIME        BIGINT       NOT NULL,
    PRIORITY          INTEGER      NOT NULL,
    STATE             VARCHAR(16)  NOT NULL,
    JOB_NAME          VARCHAR(200) NULL,
    JOB_GROUP         VARCHAR(200) NULL,
    IS_NONCONCURRENT  BOOL         NULL,
    REQUESTS_RECOVERY BOOL         NULL,
    PRIMARY KEY (SCHED_NAME, ENTRY_ID)
);

CREATE TABLE QRTZ_SCHEDULER_STATE
(
    SCHED_NAME        VARCHAR(120) NOT NULL,
    INSTANCE_NAME     VARCHAR(200) NOT NULL,
    LAST_CHECKIN_TIME BIGINT       NOT NULL,
    CHECKIN_INTERVAL  BIGINT       NOT NULL,
    PRIMARY KEY (SCHED_NAME, INSTANCE_NAME)
);

CREATE TABLE QRTZ_LOCKS
(
    SCHED_NAME VARCHAR(120) NOT NULL,
    LOCK_NAME  VARCHAR(40)  NOT NULL,
    PRIMARY KEY (SCHED_NAME, LOCK_NAME)
);

CREATE INDEX IDX_QRTZ_J_REQ_RECOVERY
    ON QRTZ_JOB_DETAILS (SCHED_NAME, REQUESTS_RECOVERY);
CREATE INDEX IDX_QRTZ_J_GRP
    ON QRTZ_JOB_DETAILS (SCHED_NAME, JOB_GROUP);

CREATE INDEX IDX_QRTZ_T_J
    ON QRTZ_TRIGGERS (SCHED_NAME, JOB_NAME, JOB_GROUP);
CREATE INDEX IDX_QRTZ_T_JG
    ON QRTZ_TRIGGERS (SCHED_NAME, JOB_GROUP);
CREATE INDEX IDX_QRTZ_T_C
    ON QRTZ_TRIGGERS (SCHED_NAME, CALENDAR_NAME);
CREATE INDEX IDX_QRTZ_T_G
    ON QRTZ_TRIGGERS (SCHED_NAME, TRIGGER_GROUP);
CREATE INDEX IDX_QRTZ_T_STATE
    ON QRTZ_TRIGGERS (SCHED_NAME, TRIGGER_STATE);
CREATE INDEX IDX_QRTZ_T_N_STATE
    ON QRTZ_TRIGGERS (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP, TRIGGER_STATE);
CREATE INDEX IDX_QRTZ_T_N_G_STATE
    ON QRTZ_TRIGGERS (SCHED_NAME, TRIGGER_GROUP, TRIGGER_STATE);
CREATE INDEX IDX_QRTZ_T_NEXT_FIRE_TIME
    ON QRTZ_TRIGGERS (SCHED_NAME, NEXT_FIRE_TIME);
CREATE INDEX IDX_QRTZ_T_NFT_ST
    ON QRTZ_TRIGGERS (SCHED_NAME, TRIGGER_STATE, NEXT_FIRE_TIME);
CREATE INDEX IDX_QRTZ_T_NFT_MISFIRE
    ON QRTZ_TRIGGERS (SCHED_NAME, MISFIRE_INSTR, NEXT_FIRE_TIME);
CREATE INDEX IDX_QRTZ_T_NFT_ST_MISFIRE
    ON QRTZ_TRIGGERS (SCHED_NAME, MISFIRE_INSTR, NEXT_FIRE_TIME, TRIGGER_STATE);
CREATE INDEX IDX_QRTZ_T_NFT_ST_MISFIRE_GRP
    ON QRTZ_TRIGGERS (SCHED_NAME, MISFIRE_INSTR, NEXT_FIRE_TIME, TRIGGER_GROUP, TRIGGER_STATE);

CREATE INDEX IDX_QRTZ_FT_TRIG_INST_NAME
    ON QRTZ_FIRED_TRIGGERS (SCHED_NAME, INSTANCE_NAME);
CREATE INDEX IDX_QRTZ_FT_INST_JOB_REQ_RCVRY
    ON QRTZ_FIRED_TRIGGERS (SCHED_NAME, INSTANCE_NAME, REQUESTS_RECOVERY);
CREATE INDEX IDX_QRTZ_FT_J_G
    ON QRTZ_FIRED_TRIGGERS (SCHED_NAME, JOB_NAME, JOB_GROUP);
CREATE INDEX IDX_QRTZ_FT_JG
    ON QRTZ_FIRED_TRIGGERS (SCHED_NAME, JOB_GROUP);
CREATE INDEX IDX_QRTZ_FT_T_G
    ON QRTZ_FIRED_TRIGGERS (SCHED_NAME, TRIGGER_NAME, TRIGGER_GROUP);
CREATE INDEX IDX_QRTZ_FT_TG
    ON QRTZ_FIRED_TRIGGERS (SCHED_NAME, TRIGGER_GROUP);
